# iHub Framework TS Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

> Given a version number `MAJOR.MINOR.PATCH`, increment the:
> 1. MAJOR version when you make incompatible API changes,
> 2. MINOR version when you add functionality in a backwards-compatible manner, and
> 3. PATCH version when you make backwards-compatible bug fixes.
>
> Additional labels for pre-release and build metadata are available as extensions to the `MAJOR.MINOR.PATCH` format.

## Changelog entry snippet

``` markdown
## [X.Y.Z] - yyyy-mm-dd

### Added
### Fixed
### Changed
### Removed
```

## Additional documentations:
* [Documentation - Wiki](https://gitlab.com/infracommerce-ihub/framework/ihub-framework-ts/wikis/home)
* [Contributing](https://gitlab.com/infracommerce-ihub/framework/ihub-framework-ts/blob/master/CONTRIBUTING.md)

## Version summary

| Tag                      | Release date |
| ------------------------ | -----------: |
| [1.5.2](#152-2020-09-30) | 2020-09-30   |
| [1.5.0](#150-2020-08-03) | 2020-08-03   |
| [1.4.1](#141-2020-06-30) | 2020-06-30   |

## [1.5.2] - 2020-09-30

### Fixed

- Validation to run job only in one process of the NodeJS

## [1.5.0] - 2020-08-03

### Changed

- Several improvements

## [1.4.1] - 2020-06-30

### Fixed

- Fixed the graceful shutdown to put `running = false` in the crontabs
