"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Database = void 0;
const mongoose_1 = __importDefault(require("mongoose"));
const index_1 = require("../index");
class Database {
    constructor(options) {
        this.connectionUrl = options.connectionUrl;
        this.enabled = options.enabled;
    }
    async start() {
        if (!this.enabled) {
            index_1.logger.debug('Database not enabled', 'ihf.database.notEnabled');
            return;
        }
        try {
            // Avoid deprecated warnings
            mongoose_1.default.set('useCreateIndex', true);
            mongoose_1.default.set('useUnifiedTopology', true);
            mongoose_1.default.set('useFindAndModify', false);
            await mongoose_1.default.connect(this.connectionUrl, { useNewUrlParser: true });
            index_1.logger.debug('Database Connected', 'ihf.database.connected');
            return mongoose_1.default;
        }
        catch (error) {
            throw Error(error);
        }
    }
}
exports.Database = Database;
//# sourceMappingURL=index.js.map