"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Models = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const mongoose_1 = __importStar(require("mongoose"));
const index_1 = require("../../index");
class Models {
    constructor(modelsPath) {
        this.modelsPath = modelsPath;
        if (!fs_1.default.existsSync(this.modelsPath)) {
            this.models = [];
            return;
        }
        this.models = fs_1.default.readdirSync(modelsPath);
        this.models = this.models.filter(model => model.match(/js$/));
    }
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    load() {
        return new Promise((resolve, reject) => {
            if (this.models.length === 0)
                resolve();
            let count = 0;
            this.models.forEach(async (model, index) => {
                count += 1;
                const modelPath = path_1.default.join(this.modelsPath, model);
                const modelLoad = await Promise.resolve().then(() => __importStar(require(modelPath)));
                const modelModule = modelLoad.default;
                // Check if what we're importing is a Component instance
                if (modelModule instanceof mongoose_1.Schema === false) {
                    return reject(`${model} is not a instance of Mongoose Schema`);
                }
                const modelName = model.replace('.js', '');
                // Check if there is a module loaded with the same name
                if (mongoose_1.default.modelNames().indexOf(modelName) > -1) {
                    return reject(`Conflicted, trying to load two models ${modelName}`);
                }
                mongoose_1.default.model(modelName, modelModule);
                index_1.models[modelName] = mongoose_1.default.model(modelName);
                index_1.logger.debug(`Model ${modelName}, loaded`, `ihf.models.${modelName}.loading`);
                // Set the component alis, we're going to use it later for the routes
                if (count === index + 1)
                    return resolve();
            });
        });
    }
}
exports.Models = Models;
//# sourceMappingURL=index.js.map