import express from 'express';
interface Headers {
    prop: string;
    value: string;
}
interface ServerOptions {
    enabled: boolean;
    jwt: string;
    headers?: Headers[];
    http?: {
        port: string;
    };
}
declare class Server implements ServerOptions {
    enabled: boolean;
    app: express.Express;
    listen: any;
    healthStatus: number;
    headers: Headers[];
    http: any;
    jwt: string;
    /**
     * Creates an instance of Server.
     * @param {ServerOptions} options
     * @memberof Server
     */
    constructor(options: ServerOptions);
    start(): Promise<Server>;
    /**
     * Healt status route ok
     * @todo Improve the return, put some information about the process
     * @memberof Server
     */
    healthz(): void;
}
export { Server, ServerOptions };
